Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DbTestApp.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DbTestApp.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DbTestApp.cs	(revision 4092)
@@ -33,8 +33,11 @@
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Tracing;
+using HeuristicLab.Hive.Server.DataAccess;
 
 namespace HeuristicLab.Hive.Server {
   [Application("Hive DB Test App", "Test Application for the Hive DataAccess Layer")]
   internal class HiveDbTestApplication : ApplicationBase {
+    private IContextFactory contextFactory = ServiceLocator.GetContextFactory();
+
     /*private void TestJobStreaming() {
       ISessionFactory factory =
@@ -150,12 +153,12 @@
 
       JobDto job = new JobDto {
-                                Client = c1,
-                                CoresNeeded = 2,
-                                DateCreated = DateTime.Now,
-                                MemoryNeeded = 500,
-                                Percentage = 0,
-                                Priority = 1,
-                                State = State.offline
-                              };
+        Client = c1,
+        CoresNeeded = 2,
+        DateCreated = DateTime.Now,
+        MemoryNeeded = 500,
+        Percentage = 0,
+        Priority = 1,
+        State = State.offline
+      };
 
       job = DaoLocator.JobDao.Insert(job);
@@ -214,5 +217,5 @@
     }
 
-
+    
     public override void Run() {
       //TestClientGroupAdapter();
@@ -221,22 +224,26 @@
       //TestJobResultStreaming();
       //TestJobResultDeserialization();
-
-      //if (ContextFactory.Context.DatabaseExists())
-      //  ContextFactory.Context.DeleteDatabase();
-      //ContextFactory.Context.CreateDatabase();
-      //TestLINQImplementation();
-      TestLinqFileHandling();
-      //StressTest();
-
-      //SpeedTest();
-      //TestJobBytearrFetching();
-      //TestJobStreamFetching();
+      using (contextFactory.GetContext(false)) {
+        if (contextFactory.CurrentContext.DatabaseExists())
+          contextFactory.CurrentContext.DeleteDatabase();
+        contextFactory.CurrentContext.CreateDatabase();
+      }
+
+      using (contextFactory.GetContext()) {
+        //TestLINQImplementation();
+        TestLinqFileHandling();
+
+        //StressTest();
+
+        //SpeedTest();
+        //TestJobBytearrFetching();
+        //TestJobStreamFetching();
+      }
+
     }
 
     private void WriteToJobWithByte(object jobid) {
       using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
-                                                           new TransactionOptions
-                                                           {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})
-        ) {
+                                                           new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
         Logger.Info("starting bytestuff for job " + jobid);
         DaoLocator.JobDao.SetBinaryJobFile((Guid)jobid, jobmap[(Guid)jobid]);
@@ -248,7 +255,5 @@
     private void UpdateJobStatus(object jobid) {
       using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
-                                                           new TransactionOptions
-                                                           {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})
-        ) {
+                                                           new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
         Thread.Sleep(1500);
         Logger.Info("starting now");
@@ -267,20 +272,20 @@
       List<Thread> jobupdateThreads = new List<Thread>();
       List<Thread> jobProgressThreads = new List<Thread>();
-      
+
       Random r = new Random();
       Stack<JobDto> jobs = new Stack<JobDto>(DaoLocator.JobDao.FindAll());
       Logger.Info("Fetched jobs");
-      for (int x = 0; x < 10 && jobs.Count > 0; x++ ) {
+      for (int x = 0; x < 10 && jobs.Count > 0; x++) {
         Logger.Info("Creating data for Job");
         JobDto job = jobs.Pop();
-        byte[] jobarr = new byte[50*1024*1024];
+        byte[] jobarr = new byte[50 * 1024 * 1024];
         for (int i = 0; i < jobarr.Length; i++) {
-          jobarr[i] = (byte) r.Next(255);
+          jobarr[i] = (byte)r.Next(255);
         }
         jobmap.Add(job.Id, jobarr);
       }
       Logger.Info("filled");
-      foreach(KeyValuePair<Guid, byte[]> kvp in jobmap) {
-        Thread tjob = new Thread(new ParameterizedThreadStart(WriteToJobWithByte));      
+      foreach (KeyValuePair<Guid, byte[]> kvp in jobmap) {
+        Thread tjob = new Thread(new ParameterizedThreadStart(WriteToJobWithByte));
         Thread tupdate = new Thread(new ParameterizedThreadStart(UpdateJobStatus));
         jobupdateThreads.Add(tupdate);
@@ -298,39 +303,19 @@
 
 
-    private
-      void TestJobStreamFetching() {
+    private void TestJobStreamFetching() {
       //using (TransactionScope scope = new TransactionScope()) {
 
-      HiveDataContext context = ContextFactory.Context;
-
-      ContextFactory.Context.Connection.Open
-        ();
-      ContextFactory.Context.Transaction
-        =
-        ContextFactory.Context.Connection.BeginTransaction
-          ();
-
+      HiveDataContext context = contextFactory.CurrentContext as HiveDataContext;
+
+      context.Connection.Open();
+      context.Transaction = context.Connection.BeginTransaction();
 
       ClientFacade facade = new ClientFacade();
-
       Stream stream = facade.SendStreamedJob(new Guid("F5CFB334-66A0-417C-A585-71711BA21D3F"));
 
-
       byte[] buffer = new byte[3024];
-
       int read = 0;
-
-      while ((
-               read
-               =
-               stream.Read
-                 (
-                 buffer
-                 , 0,
-                 buffer.Length
-                 )) > 0) {}
-
-      stream.Close
-        ();
+      while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) { }
+      stream.Close();
 
       //Stream stream = DaoLocator.JobDao.GetSerializedJobStream(new Guid("bbb51f87-4e2f-4499-a9b6-884e589c78b6"));
@@ -338,15 +323,10 @@
     }
 
-    private
-      void TestJobBytearrFetching() {
+    private void TestJobBytearrFetching() {
       byte[] arr = DaoLocator.JobDao.GetBinaryJobFile(new Guid("A3386907-2B3C-4976-BE07-04D660D40A5B"));
-      Console.WriteLine
-        (
-        arr
-        );
-    }
-
-    private
-      void SpeedTest() {
+      Console.WriteLine(arr);
+    }
+
+    private void SpeedTest() {
       DateTime start = new DateTime();
 
@@ -356,8 +336,5 @@
 
       TimeSpan used = end - start;
-      Console.WriteLine
-        (
-        used.TotalMilliseconds
-        );
+      Console.WriteLine(used.TotalMilliseconds);
     }
   }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4092)
@@ -33,64 +33,79 @@
 using HeuristicLab.Hive.Server.Core.InternalInterfaces;
 using System.Transactions;
+using HeuristicLab.Hive.Server.LINQDataAccess;
+using HeuristicLab.Hive.Server.DataAccess;
 
 namespace HeuristicLab.Hive.Server.Core {
-  [ServiceBehavior(InstanceContextMode =
-    InstanceContextMode.PerCall, ConcurrencyMode = ConcurrencyMode.Multiple)]
-  public class ClientFacade: IClientFacade {
+  [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall, ConcurrencyMode = ConcurrencyMode.Multiple)]
+  public class ClientFacade : IClientFacade {
 
-    public ClientFacade() {      
+    public ClientFacade() {
     }
 
     private IClientCommunicator clientCommunicator = ServiceLocator.GetClientCommunicator();
 
+    private IContextFactory contextFactory = ServiceLocator.GetContextFactory();
+
     #region IClientCommunicator Members
 
     public Response Login(ClientDto clientInfo) {
-      return clientCommunicator.Login(clientInfo);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.Login(clientInfo);
+      }
     }
 
     public ResponseHB ProcessHeartBeat(HeartBeatData hbData) {
-      return clientCommunicator.ProcessHeartBeat(hbData);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.ProcessHeartBeat(hbData);
+      }
     }
 
     public ResponseJob SendJob(Guid clientId) {
-      return clientCommunicator.SendJob(clientId);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.SendJob(clientId);
+      }
     }
 
-    /*public ResponseSerializedJob SendSerializedJob(Guid clientId) {
-      return clientCommunicator.SendSerializedJob(clientId);
-    } */
-
-    public ResponseResultReceived StoreFinishedJobResult(Guid clientId,
-      Guid jobId,
-      byte[] result,
-      double percentage, 
-      Exception exception) {
-      return clientCommunicator.StoreFinishedJobResult(clientId, jobId, result, percentage, exception);
+    public ResponseResultReceived StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception) {
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.StoreFinishedJobResult(clientId, jobId, result, percentage, exception);
+      }
     }
 
     public Response Logout(Guid clientId) {
-      return clientCommunicator.Logout(clientId);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.Logout(clientId);
+      }
     }
 
     public Response IsJobStillNeeded(Guid jobId) {
-      return clientCommunicator.IsJobStillNeeded(jobId);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.IsJobStillNeeded(jobId); 
+      }
     }
 
     public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
-      return clientCommunicator.SendPlugins(pluginList);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.SendPlugins(pluginList);      
+      }
     }
 
     public ResponseResultReceived ProcessSnapshot(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception) {
-      return clientCommunicator.ProcessSnapshot(clientId, jobId, result, percentage, exception);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.ProcessSnapshot(clientId, jobId, result, percentage, exception); 
+      }
     }
 
 
     public ResponseCalendar GetCalendar(Guid clientId) {
-      return clientCommunicator.GetCalendar(clientId);
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.GetCalendar(clientId); 
+      }
     }
 
-    public Response SetCalendarStatus(Guid clientId, CalendarState state) {
-      return clientCommunicator.SetCalendarStatus(clientId, state);      
+    public Response SetCalendarStatus(Guid clientId, CalendarState state) { 
+      using (contextFactory.GetContext()) {
+        return clientCommunicator.SetCalendarStatus(clientId, state);
+      }
     }
     #endregion
@@ -98,24 +113,27 @@
     #region IClientFacade Members
 
-    [SpringTransaction(UserTransaction = true)]
+    /// <summary>
+    /// Do not use automatic transactions here
+    /// </summary>
     public Stream SendStreamedJob(Guid clientId) {
-      MultiStream stream = new MultiStream();
+      using (contextFactory.GetContext(false)) {
+        MultiStream stream = new MultiStream();
 
-      ResponseJob job = null;
+        ResponseJob job = null;
 
-      job = this.SendJob(clientId);      
+        job = this.SendJob(clientId);
 
-      //first send response
-      stream.AddStream(new StreamedObject<ResponseJob>(job));
+        //first send response
+        stream.AddStream(new StreamedObject<ResponseJob>(job));
 
-      IJobManager jobManager = ServiceLocator.GetJobManager();
-      IInternalJobManager internalJobManager = (IInternalJobManager) jobManager;
-      
-      //second stream the job binary data
-      MemoryStream memoryStream = new MemoryStream();      
-      if(job.Job != null)
-        stream.AddStream(new MemoryStream(internalJobManager.GetSerializedJobDataById(job.Job.Id)));
-      
-      OperationContext clientContext = OperationContext.Current;
+        IJobManager jobManager = ServiceLocator.GetJobManager();
+        IInternalJobManager internalJobManager = (IInternalJobManager)jobManager;
+
+        //second stream the job binary data
+        MemoryStream memoryStream = new MemoryStream();
+        if (job.Job != null)
+          stream.AddStream(new MemoryStream(internalJobManager.GetSerializedJobDataById(job.Job.Id)));
+
+        OperationContext clientContext = OperationContext.Current;
         clientContext.OperationCompleted += new EventHandler(delegate(object sender, EventArgs args) {
           if (stream != null) {
@@ -124,17 +142,24 @@
         });
 
-      return stream;
+        return stream;
+      }
     }
 
     public Stream SendStreamedPlugins(List<HivePluginInfoDto> pluginList) {
-      return new StreamedObject<ResponsePlugin>(this.SendPlugins(pluginList));
+      using (contextFactory.GetContext()) {
+        return new StreamedObject<ResponsePlugin>(this.SendPlugins(pluginList));
+      }
     }
 
     public ResponseResultReceived StoreFinishedJobResultStreamed(Stream stream) {
-      return ((IInternalClientCommunicator)clientCommunicator).ProcessJobResult(stream, true);
-    } 
+      using (contextFactory.GetContext()) {
+        return ((IInternalClientCommunicator)clientCommunicator).ProcessJobResult(stream, true);
+      }
+    }
 
     public ResponseResultReceived ProcessSnapshotStreamed(Stream stream) {
-      return ((IInternalClientCommunicator)clientCommunicator).ProcessJobResult(stream, false);
+      using (contextFactory.GetContext()) {
+        return ((IInternalClientCommunicator)clientCommunicator).ProcessJobResult(stream, false);  
+      }
     }
     #endregion
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs	(revision 4092)
@@ -27,13 +27,13 @@
 using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
 
 namespace HeuristicLab.Hive.Server.Core {
-  public class ExecutionEngineFacade: IExecutionEngineFacade {
+  public class ExecutionEngineFacade : IExecutionEngineFacade {
 
-    private IJobManager jobManager =
-      ServiceLocator.GetJobManager();
+    private IJobManager jobManager = ServiceLocator.GetJobManager();
+    private IContextFactory contextFactory = ServiceLocator.GetContextFactory();
 
     public ExecutionEngineFacade() {
-      
     }
 
@@ -41,22 +41,31 @@
 
     public ResponseObject<JobDto> AddJob(SerializedJob job) {
-      return jobManager.AddNewJob(job);
+      using (contextFactory.GetContext()) {
+        return jobManager.AddNewJob(job);
+      }
     }
 
-    public ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources) {      
-      return jobManager.AddJobWithGroupStrings(job, resources);
+    public ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources) {
+      using (contextFactory.GetContext()) {
+        return jobManager.AddJobWithGroupStrings(job, resources);
+      }
     }
 
     public Response RequestSnapshot(Guid jobId) {
-      return jobManager.RequestSnapshot(jobId);
+      using (contextFactory.GetContext()) {
+        return jobManager.RequestSnapshot(jobId);
+      }
     }
 
-    public ResponseObject<SerializedJob> 
-      GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
-      return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
+    public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
+      using (contextFactory.GetContext()) {
+        return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
+      }
     }
 
     public Response AbortJob(Guid jobId) {
-      return jobManager.AbortJob(jobId);
+      using (contextFactory.GetContext()) {
+        return jobManager.AbortJob(jobId);
+      }
     }
 
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4092)
@@ -30,166 +30,223 @@
 using HeuristicLab.Hive.Server.Core.InternalInterfaces;
 using System.ServiceModel;
+using HeuristicLab.Hive.Server.DataAccess;
 
 
 namespace HeuristicLab.Hive.Server.Core {
-  public class ServerConsoleFacade: IServerConsoleFacade {
-    private IClientManager clientManager = 
-      ServiceLocator.GetClientManager();
-
-    private IJobManager jobManager = 
-      ServiceLocator.GetJobManager();
+  public class ServerConsoleFacade : IServerConsoleFacade {
+    private IClientManager clientManager = ServiceLocator.GetClientManager();
+
+    private IJobManager jobManager = ServiceLocator.GetJobManager();
 
     private IHivePermissionManager secMan = ServiceLocator.GetHivePermissionManager();
 
+    private IContextFactory contextFactory = ServiceLocator.GetContextFactory();
+
     public Guid sessionID = Guid.Empty;
 
-    public ServerConsoleFacade() {      
+    public ServerConsoleFacade() {
     }
 
     public Response Login(string username, string password) {
-      Response resp = new Response();
-     
-      sessionID = secMan.Login(username, password);
-      if (sessionID == Guid.Empty) {
-        resp.Success = false;
-        resp.StatusMessage = ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_FAILED;
-      } else {
-        resp.Success = true;
-        resp.StatusMessage =
-          ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
-      }
-      return resp;
+      using (contextFactory.GetContext()) {
+        Response resp = new Response();
+
+        sessionID = secMan.Login(username, password);
+        if (sessionID == Guid.Empty) {
+          resp.Success = false;
+          resp.StatusMessage = ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_FAILED;
+        } else {
+          resp.Success = true;
+          resp.StatusMessage =
+            ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
+        }
+        return resp;
+      }
     }
 
 
     public ResponseList<ClientDto> GetAllClients() {
-      secMan.Authorize("AccessClients", sessionID, Guid.Empty);
-      return clientManager.GetAllClients();
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessClients", sessionID, Guid.Empty);
+        return clientManager.GetAllClients();
+      }
     }
 
     public ResponseList<ClientGroupDto> GetAllClientGroups() {
-      //secMan.Authorize("AccessClientGroup", sessionID, Guid.Empty);
-      return clientManager.GetAllClientGroups();
+      using (contextFactory.GetContext()) {
+        //secMan.Authorize("AccessClientGroup", sessionID, Guid.Empty);
+        return clientManager.GetAllClientGroups();
+      }
     }
 
     public ResponseList<UpTimeStatisticsDto> GetAllUpTimeStatistics() {
-      secMan.Authorize("AccessStatistics", sessionID, Guid.Empty);
-      return clientManager.GetAllUpTimeStatistics();
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessStatistics", sessionID, Guid.Empty);
+        return clientManager.GetAllUpTimeStatistics();
+      }
     }
 
     public ResponseObject<ClientGroupDto> AddClientGroup(ClientGroupDto clientGroup) {
-      secMan.Authorize("AddClientGroup", sessionID, Guid.Empty);
-      return clientManager.AddClientGroup(clientGroup);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AddClientGroup", sessionID, Guid.Empty);
+        return clientManager.AddClientGroup(clientGroup);
+      }
     }
 
     public Response AddResourceToGroup(Guid clientGroupId, ResourceDto resource) {
-      secMan.Authorize("AddResource", sessionID, Guid.Empty);                
-      return clientManager.AddResourceToGroup(clientGroupId, resource);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AddResource", sessionID, Guid.Empty);
+        return clientManager.AddResourceToGroup(clientGroupId, resource);
+      }
     }
 
     public Response DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
+      using (contextFactory.GetContext()) {
         return clientManager.DeleteResourceFromGroup(clientGroupId, resourceId);
+      }
     }
 
     public ResponseList<JobDto> GetAllJobs() {
-      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
-      return jobManager.GetAllJobs();
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+        return jobManager.GetAllJobs();
+      }
     }
 
     public ResponseList<JobDto> GetAllJobsWithFilter(State jobState, int offset, int count) {
-      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
-      return jobManager.GetAllJobsWithFilter(jobState, offset, count);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+        return jobManager.GetAllJobsWithFilter(jobState, offset, count);
+      }
     }
 
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
-      secMan.Authorize("AccessJobs", sessionID, jobId);
-      return jobManager.GetJobById(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobs", sessionID, jobId);
+        return jobManager.GetJobById(jobId);
+      }
     }
 
     public ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId) {
-      secMan.Authorize("AccessJobs", sessionID, jobId);
-      return jobManager.GetJobByIdWithDetails(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobs", sessionID, jobId);
+        return jobManager.GetJobByIdWithDetails(jobId);
+      }
     }
 
     public ResponseObject<JobDto> AddNewJob(SerializedJob job) {
-      secMan.Authorize("AddJob", sessionID, job.JobInfo.Id);
-      return jobManager.AddNewJob(job);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AddJob", sessionID, job.JobInfo.Id);
+        return jobManager.AddNewJob(job);
+      }
     }
 
     public ResponseObject<JobDto> GetLastJobResultOf(Guid jobId) {
-      secMan.Authorize("AccessJobResults", sessionID, jobId);
-      return jobManager.GetLastJobResultOf(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobResults", sessionID, jobId);
+        return jobManager.GetLastJobResultOf(jobId);
+      }
     }
 
     public ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
-      secMan.Authorize("AccessJobResults", sessionID, jobId);
-      return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobResults", sessionID, jobId);
+        return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
+      }
     }
 
     public ResponseList<JobResult> GetAllJobResults(Guid jobId) {
-      secMan.Authorize("AccessJobResults", sessionID, jobId);  
-      return jobManager.GetAllJobResults(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobResults", sessionID, jobId);
+        return jobManager.GetAllJobResults(jobId);
+      }
     }
 
     public Response RemoveJob(Guid jobId) {
-      secMan.Authorize("RemoveJob", sessionID, jobId);
-      return jobManager.RemoveJob(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("RemoveJob", sessionID, jobId);
+        return jobManager.RemoveJob(jobId);
+      }
     }
 
     public Response RequestSnapshot(Guid jobId) {
-      secMan.Authorize("AccessJobResults", sessionID, jobId);  
-      return jobManager.RequestSnapshot(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobResults", sessionID, jobId);
+        return jobManager.RequestSnapshot(jobId);
+      }
     }
 
     public Response AbortJob(Guid jobId) {
-      secMan.Authorize("AbortJob", sessionID, Guid.Empty);
-      return jobManager.AbortJob(jobId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AbortJob", sessionID, Guid.Empty);
+        return jobManager.AbortJob(jobId);
+      }
     }
 
     public ResponseObject<List<ClientGroupDto>> GetAllGroupsOfResource(Guid resourceId) {
-      secMan.Authorize("AccessUserGroup", sessionID, Guid.Empty);
-      return clientManager.GetAllGroupsOfResource(resourceId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessUserGroup", sessionID, Guid.Empty);
+        return clientManager.GetAllGroupsOfResource(resourceId);
+      }
     }
 
     public Response DeleteClientGroup(Guid clientGroupId) {
-      secMan.Authorize("DeleteClientGroup", sessionID, Guid.Empty);
-      return clientManager.DeleteClientGroup(clientGroupId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("DeleteClientGroup", sessionID, Guid.Empty);
+        return clientManager.DeleteClientGroup(clientGroupId);
+      }
     }
 
     public ResponseList<ProjectDto> GetAllProjects() {
-      secMan.Authorize("AccessProjects", sessionID, Guid.Empty);
-      return jobManager.GetAllProjects();
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessProjects", sessionID, Guid.Empty);
+        return jobManager.GetAllProjects();
+      }
     }
 
     public Response CreateProject(ProjectDto project) {
-      secMan.Authorize("CreateProjects", sessionID, Guid.Empty);
-      return jobManager.CreateProject(project);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("CreateProjects", sessionID, Guid.Empty);
+        return jobManager.CreateProject(project);
+      }
     }
 
     public Response ChangeProject(ProjectDto project) {
-      secMan.Authorize("ChangeProjects", sessionID, Guid.Empty);
-      return jobManager.ChangeProject(project);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("ChangeProjects", sessionID, Guid.Empty);
+        return jobManager.ChangeProject(project);
+      }
     }
 
     public Response DeleteProject(Guid projectId) {
-      secMan.Authorize("DeleteProjects", sessionID, projectId);
-      return jobManager.DeleteProject(projectId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("DeleteProjects", sessionID, projectId);
+        return jobManager.DeleteProject(projectId);
+      }
     }
 
     public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
-      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
-      return jobManager.GetJobsByProject(projectId);
+      using (contextFactory.GetContext()) {
+        secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+        return jobManager.GetJobsByProject(projectId);
+      }
     }
 
     public ResponseList<AppointmentDto> GetUptimeCalendarForResource(Guid guid) {
-      return clientManager.GetUptimeCalendarForResource(guid);
+      using (contextFactory.GetContext()) {
+        return clientManager.GetUptimeCalendarForResource(guid);
+      }
     }
 
     public Response SetUptimeCalendarForResource(Guid guid, IEnumerable<AppointmentDto> appointments, bool isForced) {
-      return clientManager.SetUptimeCalendarForResource(guid, appointments, isForced);
+      using (contextFactory.GetContext()) {
+        return clientManager.SetUptimeCalendarForResource(guid, appointments, isForced);
+      }
     }
 
     public ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources) {
-      return jobManager.AddJobWithGroupStrings(job, resources);
+      using (contextFactory.GetContext()) {
+        return jobManager.AddJobWithGroupStrings(job, resources);
+      }
     }
   }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4092)
@@ -112,10 +112,10 @@
     <Compile Include="Authorization\PolicyCollection.cs" />
     <Compile Include="ClientCommunicator.cs" />
-    <Compile Include="ClientFacade.cs" />
+    <Compile Include="Facades\ClientFacade.cs" />
     <Compile Include="ClientManager.cs" />
     <Compile Include="DaoLocator.cs" />
     <Compile Include="DbTestApp.cs" />
     <Compile Include="DefaultScheduler.cs" />
-    <Compile Include="ExecutionEngineFacade.cs" />
+    <Compile Include="Facades\ExecutionEngineFacade.cs" />
     <Compile Include="Authorization\HivePermissionManager.cs" />
     <Compile Include="HiveServerCorePlugin.cs" />
@@ -128,5 +128,5 @@
     <Compile Include="LifecycleManager.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ServerConsoleFacade.cs" />
+    <Compile Include="Facades\ServerConsoleFacade.cs" />
     <Compile Include="ServiceLocator.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
